<template>
  <v-dialog v-model="dialog" persistent width="800px">
    <v-card>
      <DialogRemark
        v-if="
          objLocal.status === 'RP' ||
          objLocal.status === 'RD' ||
          objLocal.status === 'R' ||
          objLocal.status === 'RF'
        "
        :dialog="dialogRemark"
        :remark="objLocal.remark"
        :close.sync="dialogRemark"
      />
      <v-card-title>
        <span class="headline">
          <v-icon color="info"> insert_drive_file </v-icon>
          รายละเอียดฟอร์ม
        </span>
        <v-chip
          class="ma-2"
          @click="dialogRemark = true"
          v-if="
            objLocal.status === 'RP' ||
            objLocal.status === 'RD' ||
            objLocal.status === 'R' ||
            objLocal.status === 'RF'
          "
        >
          เหตุผล Read more <v-icon color="info"> label_important </v-icon>
        </v-chip>
        <v-spacer></v-spacer
        ><v-chip class="ma-2" :color="objLocal | colorStatus" label outlined>
          {{ objLocal | status }}
        </v-chip>
      </v-card-title>
      <v-card-text>
        <v-container>
          <InputLockerDetail v-model="objLocal" />
        </v-container>
      </v-card-text>
      <v-card-actions>
        <v-spacer></v-spacer>
        <v-btn
          color="success darken-1"
          text
          @click="openDialog('WD')"
          v-if="objLocal.status == 'VF' && role == 'Admin'"
        >
          อนุมัติ
        </v-btn>
        <v-btn
          color="success darken-1"
          text
          @click="openDialog('WA')"
          v-if="objLocal.status == 'WP' && role == 'Admin'"
        >
          อนุมัติชำระเงินแล้ว
        </v-btn>
        <v-btn
          color="success darken-1"
          text
          @click="approveFormandInstall()"
          v-if="objLocal.status == 'WA' && role == 'Admin'"
        >
          อนุมัติการติดตั้ง
        </v-btn>
        <v-btn
          color="success darken-1"
          text
          v-if="
            (objLocal.status == 'WD' || objLocal.status == 'RD') &&
            role == 'Admin'
          "
          @click="openDiagram(objLocal)"
        >
          สร้างผังตู้
        </v-btn>
        <v-btn
          color="success darken-1"
          text
          v-if="
            objLocal.status == 'VD' ||
            objLocal.status == 'WP' ||
            objLocal.status == 'VP' ||
            objLocal.status == 'WA' ||
            objLocal.status == 'A'
          "
          @click="openDiagram(objLocal)"
        >
          ดูผังตู้
        </v-btn>
        <!-- {{objLocal.status}} -->
        <v-btn
          color="orange darken-1"
          text
          @click="openDialog('rejectEdit')"
          v-if="objLocal.status == 'VF' && role == 'Admin'"
        >
          ส่งกลับเพื่อแก้ไขข้อมูล
        </v-btn>
        <v-btn
          color="red darken-1"
          text
          @click="openDialog('reject')"
          v-if="
            objLocal.status != 'A' && objLocal.status != 'R' && role == 'Admin'
          "
          >ไม่อนุมัติ
        </v-btn>

        <v-btn
          color="orange darken-1"
          text
          @click="openDialog('editPartner')"
          v-if="obj.status == 'RF' && role == 'Partner'"
        >
          ยืนยันการแก้ไขฟอร์ม
        </v-btn>
        <v-btn color="info darken-1" text @click="closeDialogDetail">
          ปิด
        </v-btn>
      </v-card-actions>
    </v-card>
    <DialogConfirm
      :dialog="dialogConfirm"
      v-model="remark"
      :title="objDialog.title"
      :status="status"
    >
      <template v-slot:confirm>
        <v-btn
          color="success"
          text
          :disabled="loading"
          :loading="loading"
          @click="
            status == 'editPartner' ? editForm() : confirm(status, shortStatus)
          "
        >
          ใช่
        </v-btn>
      </template>
      <template v-slot:close>
        <v-btn color="error" text :disabled="loading" @click="close">
          ไม่ใช่
        </v-btn>
      </template>
    </DialogConfirm>
    <DialogDiagram
      :obj="objLocal"
      :overlay="overlayDiagram"
      :dlayouts="dlayouts"
      :dialogDiagram="dialogDiagram"
      @closedialog="closeDialog"
      @updateTable="updateTable"
      :close.sync="dialogDiagram"
      @click="openDialog"
      v-if="
        objLocal.status == 'VD' ||
        objLocal.status == 'WP' ||
        objLocal.status == 'VP' ||
        objLocal.status == 'WA' ||
        objLocal.status == 'A' ||
        objLocal.status == 'WD' ||
        objLocal.status == 'RD'
      "
    />
  </v-dialog>
</template>

<script>
import InputLockerDetail from "./InputLockerDetail";
import DialogConfirm from "../dialog/DialogConfirm";
import DialogRemark from "../dialog/DialogRemark";
import DialogDiagram from "./DialogDiagram";
export default {
  props: ["dialog", "obj"],
  model: {
    prop: "obj",
    event: "objChange",
  },
  data() {
    return {
      role: this.$store.getters["auth/roleUser"],
      loading: false,
      objDialog: {},
      objDiagram: {},
      remark: "",
      status: "",
      shortStatus: "",
      dialogConfirm: false,
      dialogRemark: false,
      dialogDiagram: false,
      overlay: true,
      overlayDiagram: false,
      dlayouts: [
        {
          breakpoint: "lg",
          breakpointWidth: 1200,
          numberOfCols: 8,
          items: [],
        },
      ],
    };
  },
  components: {
    InputLockerDetail,
    DialogConfirm,
    DialogRemark,
    DialogDiagram,
  },
  computed: {
    objLocal: {
      get: function () {
        return this.obj;
      },
      set: function (value) {
        this.$emit("objChange", value);
      },
    },
  },
  methods: {
    closeDialogDetail() {
      this.$emit("update:close", false);
    },
    close() {
      this.dialogConfirm = false;
      this.remark = "";
    },
    closeDialog(i) {
      this.$emit("update:close", i);
      this.remark = "";
    },
    // openDiagram() {
    //   this.dialogDiagram = true;
    // },
    async openDiagram(i) {
      this.dialogDiagram = true;
      this.overlayDiagram = true;
      if (
        this.objLocal.status == "RD" ||
        this.objLocal.status == "VD" ||
        this.objLocal.status == "WP" ||
        this.objLocal.status == "VP" ||
        this.objLocal.status == "WA" ||
        this.objLocal.status == "A"
      ) {
        await this.$store.dispatch("locker/getDiagram", i.lockerId);
        let diagram = this.$store.getters["locker/lockerDiagram"];
        this.dlayouts[0].items = [];
        setTimeout(() => {
          for (let i in diagram) {
            let roomCode = diagram[i].lkRoomCode.substring(0, 1);
            let item;
            if (roomCode === "S") {
              item = {
                id: `${diagram[i].lkRoomCode}`,
                x: parseInt(diagram[i].columnPosition),
                y: parseInt(diagram[i].rowPosition),
                width: 1,
                height: 1,
                lkRoomId: diagram[i].lkRoomId,
                locked: false,
              };
            }
            if (roomCode === "M") {
              item = {
                id: `${diagram[i].lkRoomCode}`,
                x: parseInt(diagram[i].columnPosition),
                y: parseInt(diagram[i].rowPosition),
                width: 1,
                height: 2,
                lkRoomId: diagram[i].lkRoomId,
                locked: false,
              };
            }
            if (roomCode === "L") {
              item = {
                id: `${diagram[i].lkRoomCode}`,
                x: parseInt(diagram[i].columnPosition),
                y: parseInt(diagram[i].rowPosition),
                width: 1,
                height: 3,
                lkRoomId: diagram[i].lkRoomId,
                locked: false,
              };
            }
            this.dlayouts[0].items.push(item);
          }
          this.overlayDiagram = false;
        }, 2000);
      } else if (this.objLocal.status == "WD" || this.objLocal.status == "VF") {
        this.dlayouts[0].items = [];

        setTimeout(() => {
          for (let j = 0; j < this.objLocal.sAmount; j++) {
            let count = parseInt(j) + 1;
            let number = j < 10 ? `0${count}` : count;
            let item = {
              id: `S${number}`,
              x: j,
              y: 0,
              width: 1,
              height: 1,
              locked: false,
            };
            this.dlayouts[0].items.push(item);
          }
          for (let j = 0; j < this.objLocal.mAmount; j++) {
            let count = parseInt(j) + 1;
            let number = j < 10 ? `0${count}` : count;
            let item = {
              id: `M${number}`,
              x: j,
              y: 1,
              width: 1,
              height: 2,
              locked: false,
            };
            this.dlayouts[0].items.push(item);
          }
          for (let j = 0; j < this.objLocal.lAmount; j++) {
            let count = parseInt(j) + 1;
            let number = j < 10 ? `0${count}` : count;
            let item = {
              id: `L${number}`,
              x: j,
              y: 2,
              width: 1,
              height: 3,
              locked: false,
            };
            this.dlayouts[0].items.push(item);
          }
        }, 2000);
        this.overlayDiagram = false;
      }
      for (let i in this.dlayouts[0].items) {
        this.dlayouts[0].items[i].locked = true;
      }
    },
    openDialog(item) {
      if (item === "rejectEdit") {
        this.dialogConfirm = true;
        this.objLocalDialog.title = "คุณต้องการส่งกลับให้แก้ไขหรือไม่";
        this.status = "reject";
        this.shortStatus = "RF";
      } else if (item === "editPartner") {
        this.dialogConfirm = true;
        this.objDialog.title = "คุณต้องการแก้ไขหรือไม่";
        this.status = "editPartner";
      } else if (item === "reject") {
        this.dialogConfirm = true;
        this.objDialog.title = "คุณต้องการไม่อนุมัติหรือไม่";
        this.status = "reject";
        this.shortStatus = "R";
      } else if (item === "approveDPartner") {
        this.dialogConfirm = true;

        this.objDialog.title = "คุณต้องการอนุมัติหรือไม่";
        this.status = "approve";
        this.shortStatus = "WP";
      } else if (item === "rejectDPartner") {
        this.dialogConfirm = true;
        this.objDialog.title = "คุณต้องการไม่อนุมัติหรือไม่";
        this.status = "reject";
        this.shortStatus = "RD";
      } else {
        this.dialogConfirm = true;
        this.objDialog.title = "คุณต้องการอนุมัติหรือไม่";
        this.status = "approve";
        this.shortStatus = item;
      }
    },
    async approveFormandInstall() {
      this.loading = true;
      let param = {
        id: this.objLocal.formId,
      };
      await this.$store.dispatch("locker/approveFormandInstall", param);
      let error = this.$store.getters["locker/error"];
      if (error === false) {
        await this.$store.dispatch("snackbar/showSnack", {
          text: "อนุมัติสำเร็จ",
          color: "success",
          timeout: 3000,
        });
        this.dialogConfirm = false;
        this.loading = false;
        this.$emit("update:close", false);
        this.$emit("update-table", true);
      } else {
        await this.$store.dispatch("snackbar/showSnack", {
          text: "ข้อมูลจากระบบผิดพลาด",
          color: "red",
          timeout: 3000,
        });
        this.dialogConfirm = false;
        this.loading = false;
        this.$emit("update-table", true);
      }
    },
    async editForm() {
      this.loading = true;
      const param = {
        formId: this.objLocal.formId,
        sAmount: this.objLocal.sAmount,
        mAmount: this.objLocal.mAmount,
        lAmount: this.objLocal.lAmount,
        optionalRequest: this.objLocal.optionalRequest,
        accountId: localStorage.getItem("accountId"),
        locateId: this.objLocal.locateId,
      };
      await this.$store.dispatch("locker/addLockerRequest", param);
      let error = this.$store.getters["locker/error"];
      if (error === false) {
        await this.$store.dispatch("snackbar/showSnack", {
          text: "ดำเนินการสำเร็จ",
          color: "success",
          timeout: 3000,
        });
        this.dialogConfirm = false;
        this.loading = false;
        this.$emit("update:close", false);
        this.$emit("update-table", true);
      } else {
        await this.$store.dispatch("snackbar/showSnack", {
          text: "ข้อมูลจากระบบผิดพลาด",
          color: "red",
          timeout: 3000,
        });
        this.dialogConfirm = false;
        this.loading = false;
        this.$emit("update-table", true);
      }
    },
    updateTable(i) {
      if (i) this.$emit("update-table", i);
    },
    async confirm(item, status) {
      this.loading = true;
      let param;
      if (item === "approve") {
        param = {
          id: this.objLocal.formId,
          status: status,
        };
      } else if (item === "reject") {
        param = {
          id: this.objLocal.formId,
          status: status,
          remark: this.remark,
        };
      }
      await this.$store.dispatch("locker/approveForm", param);
      let error = this.$store.getters["locker/error"];
      if (error === false) {
        await this.$store.dispatch("snackbar/showSnack", {
          text: "ดำเนินการสำเร็จ",
          color: "success",
          timeout: 3000,
        });
        this.dialogConfirm = false;
        this.loading = false;
        this.dialogDiagram = false;
        this.$emit("update:close", false);
        this.$emit("update-table", true);
      } else {
        await this.$store.dispatch("snackbar/showSnack", {
          text: "ข้อมูลจากระบบผิดพลาด",
          color: "red",
          timeout: 3000,
        });
        this.dialogConfirm = false;
        this.loading = false;
        this.$emit("update-table", true);
      }
    },
  },
};
</script>

<style>
</style>